//---------------------------------------------------------------------
//		o̓vOCݒ_CAO
//---------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>
#include <commctrl.h>
#include <pdh.h>
#include "wait.h"
#include "resource.h"

//ptH[}Xj^p
static BOOL pm_selected = false;
static TCHAR pm_path[MAXPATH];

//֐
static BOOL CALLBACK config_proc(HWND, UINT, WPARAM, LPARAM);
static BOOL dlg_init(HWND, WAIT_CONF *);
static BOOL dlg_ok(HWND);
static void dlg_exit(HWND);
static void dlg_pmselsect(HWND);
static void dlg_checkedit(HWND, WPARAM);
static void CALLBACK dlg_timer_proc(HWND, UINT, UINT, DWORD);
// G[o
static void errormsg_nocheck(HWND);
static void errormsg_nopath(HWND);
static void errormsg_pmbadcond(HWND);

int func_cfg(HINSTANCE dll, HWND hwnd, WAIT_CONF *param)
{
	INITCOMMONCONTROLSEX icex;

	icex.dwSize = sizeof(icex);
	icex.dwICC = ICC_DATE_CLASSES;

	InitCommonControlsEx(&icex);

	__asm{ emms }

	return DialogBoxParam(dll, MAKEINTRESOURCE(IDD_WAIT_CONFING), hwnd, config_proc, (LPARAM)param);
}

static BOOL CALLBACK config_proc( HWND hdlg,UINT umsg,WPARAM wparam, LPARAM lparam )
{
	switch( umsg ) {
		case WM_INITDIALOG:
			return dlg_init(hdlg, (WAIT_CONF *)lparam);
		case WM_DESTROY:
			dlg_exit(hdlg);
		case WM_COMMAND:
			switch( LOWORD(wparam) )
			{
			case IDC_PMSEL:
				dlg_pmselsect(hdlg);
				break;
			case IDCANCEL:
				dlg_exit(hdlg);
				EndDialog(hdlg,LOWORD(wparam));
				break;
			case IDOK:
				if(!dlg_ok(hdlg)) break;
				dlg_exit(hdlg);
				EndDialog(hdlg,LOWORD(wparam));
				break;
			}
			if(HIWORD(wparam)==EN_KILLFOCUS)
				dlg_checkedit(hdlg, wparam);
			break;
	}
	return FALSE;
}

static BOOL dlg_init(HWND hdlg, WAIT_CONF *param)
{
	SetWindowLong(hdlg, GWL_USERDATA, (LONG)(void *)param);

	//I
	if(param->mode == MODE_OR){
		SendDlgItemMessage(hdlg, IDC_OR, BM_SETCHECK, 1, 0);
	}else{ // MODE_AND
		SendDlgItemMessage(hdlg, IDC_AND, BM_SETCHECK, 1, 0);
	}

	//ptH[}Xj^
	if(param->isNT){
		SendDlgItemMessage(hdlg, IDC_OVER, BM_SETCHECK, param->pm.enable_over, 0);
		SendDlgItemMessage(hdlg, IDC_UNDER, BM_SETCHECK, param->pm.enable_under, 0);
		SendDlgItemMessage(hdlg, IDC_PM_SPIN, UDM_SETRANGE32, 1, 3600);
		SetDlgItemInt(hdlg, IDC_OVERVAL, param->pm.over, TRUE);
		SetDlgItemInt(hdlg, IDC_UNDERVAL, param->pm.under, TRUE);
		SetDlgItemInt(hdlg, IDC_PMIVAL, param->pm.interval, TRUE);
		pm_selected = param->pm.path_selected;
		if(pm_selected){ //j^OJn
			memcpy(pm_path, param->pm.PathBuffer, sizeof(pm_path));
			SetDlgItemText(hdlg, IDC_PMPATH, TEXT(pm_path));
			dlg_timer_proc(hdlg, PM_INIT, ID_DLGTIMER, 0);
		}
	}else{
		pm_selected = false;
		EnableWindow(GetDlgItem(hdlg,IDC_OVER),FALSE);
		EnableWindow(GetDlgItem(hdlg,IDC_UNDER),FALSE);
		EnableWindow(GetDlgItem(hdlg,IDC_PMSEL),FALSE);
		EnableWindow(GetDlgItem(hdlg,IDC_OVERVAL),FALSE);
		EnableWindow(GetDlgItem(hdlg,IDC_UNDERVAL),FALSE);
		EnableWindow(GetDlgItem(hdlg,IDC_PMIVAL),FALSE);
		EnableWindow(GetDlgItem(hdlg,IDC_PM_SPIN),FALSE);
	}

	//c莞
	SendDlgItemMessage(hdlg, IDC_IVAL_SPIN, UDM_SETRANGE32, 1, 3600);
	SetDlgItemInt(hdlg, IDC_FNUM, param->fnum, TRUE);
	SetDlgItemInt(hdlg, IDC_IVAL, param->interval, TRUE);

	//^C}[
	SendDlgItemMessage(hdlg, IDC_TIMER, BM_SETCHECK, param->tm.enable, 0);
	DateTime_SetSystemtime(GetDlgItem(hdlg,IDC_TIMERPIC), GDT_VALID, &param->tm.time);

	//
	SendDlgItemMessage(hdlg, IDC_DATETIME, BM_SETCHECK, param->dt.enable, 0);
	DateTime_SetSystemtime(GetDlgItem(hdlg,IDC_DATEPIC), GDT_VALID, &param->dt.time);
	DateTime_SetSystemtime(GetDlgItem(hdlg,IDC_TIMEPIC), GDT_VALID, &param->dt.time);
	
	return TRUE;
}

static BOOL dlg_ok(HWND hdlg)
{
	WAIT_CONF  *p_wconfig;
	SYSTEMTIME st0, st1;
	BOOL       translated;
	int        val;

	p_wconfig = (WAIT_CONF *)GetWindowLong(hdlg, GWL_USERDATA);

	//I
	if(IsDlgButtonChecked(hdlg, IDC_OR)){
		p_wconfig->mode = MODE_OR;
	}else if(IsDlgButtonChecked(hdlg, IDC_AND)){
		p_wconfig->mode = MODE_AND;
	}else{
		//ɂ͂Ȃ
		p_wconfig->mode = 0;
	}

	//ptH[}Xj^
	if(p_wconfig->isNT){
		p_wconfig->pm.enable_over = IsDlgButtonChecked(hdlg, IDC_OVER);
		p_wconfig->pm.enable_under = IsDlgButtonChecked(hdlg, IDC_UNDER);
		val = GetDlgItemInt(hdlg, IDC_OVERVAL, &translated, TRUE);
		p_wconfig->pm.over = translated ? val : 0;
		val = GetDlgItemInt(hdlg, IDC_UNDERVAL, &translated, TRUE);
		p_wconfig->pm.under = translated ? val : 0;
		val = GetDlgItemInt(hdlg, IDC_PMIVAL, &translated, TRUE);
		if(translated && val>3600) val = 3600;
		else if(!translated || val<1) val = 1;
		p_wconfig->pm.interval = val;

		p_wconfig->pm.path_selected = pm_selected;
		if(pm_selected){
            memcpy(p_wconfig->pm.PathBuffer, pm_path, sizeof(pm_path));
		}
	}else{
		p_wconfig->pm.enable_over = false;
		p_wconfig->pm.enable_under = false;
	}

	//c莞
	val = GetDlgItemInt(hdlg, IDC_FNUM, &translated, TRUE);
	if(!translated || val<0) val = 0;
	p_wconfig->fnum = val;
	val = GetDlgItemInt(hdlg, IDC_IVAL, &translated, TRUE);
	if(translated && val>3600) val = 3600;
	else if(!translated || val<1) val = 1;
	p_wconfig->interval = val;


	//^C}[
	p_wconfig->tm.enable = IsDlgButtonChecked(hdlg, IDC_TIMER);
	DateTime_GetSystemtime(GetDlgItem(hdlg,IDC_TIMERPIC), &st0);
	p_wconfig->tm.time = st0;

	//
	p_wconfig->dt.enable = IsDlgButtonChecked(hdlg, IDC_DATETIME);
	DateTime_GetSystemtime(GetDlgItem(hdlg,IDC_DATEPIC), &st0);
	DateTime_GetSystemtime(GetDlgItem(hdlg,IDC_TIMEPIC), &st1);
	st0.wHour = st1.wHour;
	st0.wMinute = st1.wMinute;
	st0.wSecond = st1.wSecond;
	st0.wMilliseconds = st1.wMilliseconds;
	p_wconfig->dt.time = st0;

	//ݒ`FbN
	if(!p_wconfig->dt.enable && !p_wconfig->tm.enable 
		&& !p_wconfig->pm.enable_over && !p_wconfig->pm.enable_under)
	{
		errormsg_nocheck(hdlg);
		return FALSE;
	}
	if(p_wconfig->pm.enable_over || p_wconfig->pm.enable_under)	{
		if(!pm_selected){
			errormsg_nopath(hdlg);
			return FALSE;
		}
	}
	if(p_wconfig->pm.enable_over && p_wconfig->pm.enable_under 
		&& (p_wconfig->mode == MODE_AND))
	{
		if(p_wconfig->pm.over > p_wconfig->pm.under){
			errormsg_pmbadcond(hdlg);
			return FALSE;
		}
	}

	return TRUE;
}

static void dlg_pmselsect(HWND hdlg)
{	
	PDH_STATUS      pdhStatus;
	PDH_BROWSE_DLG_CONFIG  BrowseDlgData;

	// Zero the contents of the structure.
	memset (&BrowseDlgData, 0, sizeof(PDH_BROWSE_DLG_CONFIG));

	// Initialize the browser dialog window settings.
	BrowseDlgData.bIncludeInstanceIndex = FALSE;   
	BrowseDlgData.bSingleCounterPerAdd = TRUE;
	BrowseDlgData.bSingleCounterPerDialog = TRUE;  
	BrowseDlgData.bLocalCountersOnly = FALSE;      
	BrowseDlgData.bWildCardInstances = TRUE;
	BrowseDlgData.bHideDetailBox = TRUE;
	BrowseDlgData.bInitializePath = FALSE;     
	BrowseDlgData.bDisableMachineSelection = FALSE;
	BrowseDlgData.bIncludeCostlyObjects = FALSE;
	BrowseDlgData.bReserved = TRUE;
	BrowseDlgData.hWndOwner = hdlg;   
	BrowseDlgData.bReserved = FALSE;           
	BrowseDlgData.szReturnPathBuffer = pm_path;
	BrowseDlgData.cchReturnPathLength = MAXPATH;
	BrowseDlgData.pCallBack = NULL;   
	BrowseDlgData.dwCallBackArg = 0;
	BrowseDlgData.CallBackStatus = ERROR_SUCCESS;
	BrowseDlgData.dwDefaultDetailLevel = PERF_DETAIL_ADVANCED;
	BrowseDlgData.szDialogBoxCaption = TEXT("j^JE^[IĂ");

	// Display the counter browser window.
	pdhStatus = PdhBrowseCounters (&BrowseDlgData);
	if(pdhStatus == ERROR_SUCCESS){
		if(pm_selected){
			dlg_timer_proc(hdlg, PM_CHANGE, ID_DLGTIMER, 0);
		}else{
			dlg_timer_proc(hdlg, PM_INIT, ID_DLGTIMER, 0);
		}
		SetDlgItemText(hdlg, IDC_PMPATH, TEXT(pm_path));
		pm_selected = TRUE;
	}
}

static void dlg_exit(HWND hdlg)
{
	if(pm_selected){
		KillTimer(hdlg, ID_DLGTIMER);
		dlg_timer_proc(hdlg, PM_EXIT, ID_DLGTIMER, 0);
		pm_selected = false;
	}
}

static void dlg_checkedit(HWND hdlg, WPARAM wparam)
{
	BOOL translated;
	int val;

	switch( LOWORD(wparam) )
	{
	case IDC_PMIVAL:
		val = (int)GetDlgItemInt(hdlg, IDC_PMIVAL, &translated, TRUE);
		if(translated && val>3600) val = 3600;
		else if(!translated || val<1) val = 1;
		SetDlgItemInt(hdlg, IDC_PMIVAL, val, TRUE);
		break;
	case IDC_IVAL:
		val = (int)GetDlgItemInt(hdlg, IDC_IVAL, &translated, TRUE);
		if(translated && val>3600) val = 3600;
		else if(!translated || val<1) val = 1;
		SetDlgItemInt(hdlg, IDC_IVAL, val, TRUE);
		break;
	case IDC_FNUM:
		val = (int)GetDlgItemInt(hdlg, IDC_FNUM, &translated, TRUE);
		if(!translated || val<0) val = 0;
		SetDlgItemInt(hdlg, IDC_FNUM, val, TRUE);
		break;
	case IDC_UNDERVAL:
		val = (int)GetDlgItemInt(hdlg, IDC_UNDERVAL, &translated, TRUE);
		if(!translated || val<0) val = 0;
		SetDlgItemInt(hdlg, IDC_UNDERVAL, val, TRUE);
		break;
	case IDC_OVERVAL:
		val = (int)GetDlgItemInt(hdlg, IDC_OVERVAL, &translated, TRUE);
		if(!translated || val<0) val = 0;
		SetDlgItemInt(hdlg, IDC_OVERVAL, val, TRUE);
		break;
	}
}

//_CAOł̃ptH[}Xj^[\XV
static void CALLBACK dlg_timer_proc(HWND hdlg, UINT message, UINT iTimerID, DWORD dwTime)
{
	static HQUERY          hQuery;
	static HCOUNTER        *pCounterHandle = NULL;
	PDH_STATUS      pdhStatus;
	PDH_FMT_COUNTERVALUE   fmtValue;
	DWORD           ctrType;
	static TCHAR     buff[256];

	if(iTimerID != ID_DLGTIMER)
		return;

	switch(message)
	{
	case WM_TIMER:
		// Get the current data values.
		pdhStatus = PdhCollectQueryData (hQuery);
		if (pdhStatus == ERROR_SUCCESS && pCounterHandle != NULL) {
			pdhStatus = PdhGetFormattedCounterValue(*pCounterHandle,PDH_FMT_DOUBLE,&ctrType,&fmtValue);
		}
		if (pdhStatus == ERROR_SUCCESS && pCounterHandle != NULL) {
			_sntprintf(buff,255,TEXT("%.20g"), fmtValue.doubleValue);
		} else {
			// Print the error value.
			_sntprintf(buff,255,TEXT("ERROR")); 
		}
		SetDlgItemText(hdlg, IDC_PMVAL, TEXT(buff));
		break;
	case PM_INIT:
		// Open the query object.
		pdhStatus = PdhOpenQuery(0, 0, &hQuery);
		if (pdhStatus == ERROR_SUCCESS){
			pCounterHandle = (HCOUNTER *)GlobalAlloc(GPTR, sizeof(HCOUNTER));
		}
		if(pCounterHandle != NULL){
			pdhStatus = PdhAddCounter(hQuery, pm_path, 0, pCounterHandle);
		}
		// "Prime" counters that need two values to display a 
		//   formatted value.
		if (pdhStatus == ERROR_SUCCESS){
            pdhStatus = PdhCollectQueryData(hQuery);
		}
		SetTimer(hdlg, ID_DLGTIMER, DLG_SAMPLE_INTERVAL_MS, dlg_timer_proc);
		break;
	case PM_CHANGE:
		if(pCounterHandle != NULL){
			pdhStatus = PdhRemoveCounter(*pCounterHandle);
			pdhStatus = PdhAddCounter(hQuery, pm_path, 0, pCounterHandle);
			pdhStatus = PdhCollectQueryData(hQuery);
		}
		break;
	case PM_EXIT:
		if(pCounterHandle != NULL){
			pdhStatus = PdhRemoveCounter(*pCounterHandle);
			pdhStatus = PdhCloseQuery(hQuery);
			GlobalFree(pCounterHandle);
			pCounterHandle = NULL;
		}
		break;
	}
}

//G[bZ[W
static void errormsg_nocheck(HWND hdlg)
{
	MessageBox(hdlg, TEXT("IЂƂw肳Ă܂"), NULL, MB_OK|MB_ICONERROR);
}

static void errormsg_nopath(HWND hdlg)
{
	MessageBox(hdlg, TEXT("ptH[}Xj^̊Ďڂw肵Ă"), NULL, MB_OK|MB_ICONERROR);
}

static void errormsg_pmbadcond(HWND hdlg)
{
	MessageBox(hdlg, TEXT("ptH[}Xj^̏sł"), NULL, MB_OK|MB_ICONERROR);
}
