//----------------------------------------------------------------------------------
//		tEFCgvOC(o̓vOC)
//----------------------------------------------------------------------------------
#include <windows.h>
#include <pdh.h>
#include <stdio.h>
#include <tchar.h>

#include "output.h"
#include "resource.h"
#include "wait.h"


// G[o
static void errormsg_wtimer(void);
static void errormsg_nocond(void);
static void errormsg_timer(void);
static void errormsg_pmpath(void);

static void print_log(TCHAR *);
static void CALLBACK pm_timer_proc(HWND, UINT, UINT, DWORD);

//---------------------------------------------------------------------
//		o̓vOC\̒`
//---------------------------------------------------------------------
OUTPUT_PLUGIN_TABLE output_plugin_table = {
	NULL,
	"o̓EFCg",
	"LogFile (*.log)\0*.log\0AllFile (*.*)\0*.*\0",
	"o̓EFCg version 1.0 By",
	func_init,
	NULL,
	func_output,
	func_config,
	func_config_get,
	func_config_set,
};


//---------------------------------------------------------------------
//		o̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C OUTPUT_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetOutputPluginTable( void )
{
	return &output_plugin_table;
}


//---------------------------------------------------------------------
//		o̓vOCϐ
//---------------------------------------------------------------------
static WAIT_CONF wconfig;
static FILE *g_fp;

//---------------------------------------------------------------------
//		o̓vOCo͊֐
//---------------------------------------------------------------------
BOOL func_output( OUTPUT_INFO *oip )
{
	SYSTEMTIME st;
	ULARGE_INTEGER start,now,end;
	HANDLE hTimer = NULL;
	BOOL abort = false;

	//true ŏ𖞂Ƃ킷
	BOOL time_elapsed = true;
	PM_STATE pms;
	pms.over = true;
	pms.under = true;

	__asm{ emms }

	//O
	g_fp = _tfopen(oip->savefile,"a+");
	if(g_fp == NULL ) return FALSE;


	//ݒ肳ĂȂ
	if(!wconfig.dt.enable && !wconfig.tm.enable 
		&& !wconfig.pm.enable_over && !wconfig.pm.enable_under)
	{
		errormsg_nocond();
		fclose(g_fp);
		return TRUE; //ob`폜
	}

	//^C}[orw
	if(wconfig.tm.enable || wconfig.dt.enable){
		LARGE_INTEGER liDueTime, liTimer, liDatetime;

		//^C}[w
		if(wconfig.tm.enable){
			int tmp;

			st = wconfig.tm.time;
			tmp = ((st.wHour * 60) + st.wMinute) * 60 + st.wSecond;
			if(tmp<0) { //ɂȂ邱Ƃ͂Ȃ͂
				errormsg_timer();
				fclose(g_fp);
				return TRUE;
			}
			liTimer.QuadPart = -tmp * 10000000; //100ns
		}

		//w
		if(wconfig.dt.enable){
			GetLocalTime(&st);
			SystemTimeToFileTime(&st, (LPFILETIME)&now);
			SystemTimeToFileTime(&wconfig.dt.time, (LPFILETIME)&end);
			//ΎԂɕϊ
			if (end.QuadPart > now.QuadPart) {
				liDatetime.QuadPart = now.QuadPart - end.QuadPart;
			} else { //łɏ𖞂ĂƂ1bŃ^CAEg
				liDatetime.QuadPart = -10000000;
			}
		}

		//^C}[+w
		if(wconfig.tm.enable && wconfig.dt.enable){ //^C}[+w
			if(wconfig.mode == MODE_AND) { //AND̏ꍇ͒xI
				liDueTime = liTimer.QuadPart<liDatetime.QuadPart ? liTimer : liDatetime;
			} else { //OȐꍇ͑I
				liDueTime = liTimer.QuadPart>liDatetime.QuadPart ? liTimer : liDatetime;
			}
		}else if(wconfig.tm.enable){ //^C}[w
			liDueTime = liTimer;
		}else{ //w
			liDueTime = liDatetime;
		}

		// Create a waitable timer.
		hTimer = CreateWaitableTimer(NULL, TRUE, "WaitableTimer");
		if (!hTimer){
			errormsg_wtimer();
			fclose(g_fp);
			return FALSE;
		}
		if (!SetWaitableTimer(hTimer, &liDueTime, 0, NULL, NULL, 0))
		{
			errormsg_wtimer();
			fclose(g_fp);
			return FALSE;
		}

		//c莞ԕ\p
		GetLocalTime(&st);
		SystemTimeToFileTime(&st, (LPFILETIME)&start);
		end.QuadPart = start.QuadPart - liDueTime.QuadPart;

		//
		time_elapsed = false;
	}

	//c莞ԕ\Ԋu
	DWORD interval = wconfig.interval * 1000;

	if(wconfig.isNT){ //NT
		//ptH[}Xj^[ݒ
		if(wconfig.pm.enable_over || wconfig.pm.enable_under){
			pm_timer_proc(NULL, PM_INIT, NULL, (DWORD)&pms);
			//ptH[}Xj^[p͎c莞ԕ\Ȃ
			interval = INFINITE;
		}
	}

	// number of handles to wait on
	int cObjects = hTimer ? 1 : 0;

	//O
	print_log("start");

	////C[v
	while(true){
		DWORD result;
		/*MSG msg;

		// Read all of the messages in this next loop, 
		// removing each message as we read it.
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
		{ 
			// If it is a quit message, exit.
			if (msg.message == WM_QUIT)  
				return FALSE; 
			// Otherwise, dispatch the message.
			DispatchMessage(&msg); 
		} // End of PeekMessage while loop.
		*/

		result = MsgWaitForMultipleObjects(cObjects, &hTimer, FALSE, interval, QS_ALLINPUT); 
		if(result == WAIT_OBJECT_0 && cObjects){
			time_elapsed = true;
		}

		//𖞂ǂH
		if(wconfig.mode == MODE_OR){ //OR
			if((time_elapsed && hTimer) || (wconfig.pm.enable_over && pms.over)
				|| (wconfig.pm.enable_under && pms.under))
				break;
		}else{ //AND
			if(time_elapsed && pms.over && pms.under)
				break;
		}

		//\ƒf
		if( oip->func_is_abort() ){
			abort = true;
			break;
		}
		if(interval != INFINITE){
			int i;
			double s,n,e;

			GetLocalTime(&st);
			SystemTimeToFileTime(&st, (LPFILETIME)&now);
			s = start.QuadPart;
			n = now.QuadPart;
			e = end.QuadPart;

			if(wconfig.fnum){
				i = wconfig.fnum * (n - s)/(e - s);
				oip->func_rest_time_disp(i,wconfig.fnum);
			}else{
				i = oip->n * (n - s)/(e - s);
				oip->func_rest_time_disp(i,oip->n);
			}
		}
	} // C[v

	//N[Abv
	if(wconfig.isNT){
		if(wconfig.pm.enable_over || wconfig.pm.enable_under){
			KillTimer(NULL, pms.timerid);
			pm_timer_proc(NULL, PM_EXIT, NULL, 0);
		}
	}
	if(hTimer) CloseHandle(hTimer);

	//f̏ꍇ̓ob`Ɏc悤ɂ
	if(abort){
		print_log("aborted");
		fclose(g_fp);
		return FALSE;
	}

	print_log("end");
	fclose(g_fp);
	return TRUE;
}


//---------------------------------------------------------------------
//		o̓vOCݒ֐
//---------------------------------------------------------------------
BOOL func_config( HWND hwnd,HINSTANCE dll_hinst )
{
	return func_cfg(dll_hinst, hwnd, &wconfig);
}

int func_config_get( void *data,int size )
{
	if( data ) memcpy(data,&wconfig,sizeof(wconfig));
	return sizeof(wconfig);
}

int func_config_set( void *data,int size )
{
	if( size != sizeof(wconfig) ) return NULL;
	memcpy(&wconfig,data,size);
	return size;
}

//---------------------------------------------------------------------
//		vOC֐
//---------------------------------------------------------------------
BOOL func_init( void )
{
	SYSTEMTIME st;
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

	memset(&wconfig, 0 ,sizeof(wconfig));

	//NT or 9x̃`FbN
	GetVersionEx (&osvi);
	wconfig.isNT = (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) && (osvi.dwMajorVersion> 4);

	//ݒ̏l
	wconfig.interval = 2;
	wconfig.pm.interval = 10;
	GetLocalTime(&st);
	wconfig.dt.time = st;
	st.wHour = st.wMilliseconds = st.wMinute = st.wSecond = 0;
	wconfig.tm.time = st;

	return true;

}

//ptH[}Xj^[Ď
static void CALLBACK pm_timer_proc(HWND hdlg, UINT message, UINT iTimerID, DWORD dwTime)
{
	static HQUERY          hQuery;
	static HCOUNTER        *pCounterHandle = NULL;
	PDH_STATUS      pdhStatus;
	PDH_FMT_COUNTERVALUE   fmtValue;
	DWORD           ctrType;
	static PM_STATE *p_pms;

	switch(message)
	{
	case WM_TIMER:
		// Get the current data values.
		pdhStatus = PdhCollectQueryData (hQuery);
		if (pdhStatus == ERROR_SUCCESS && pCounterHandle != NULL) {
			pdhStatus = PdhGetFormattedCounterValue(*pCounterHandle,PDH_FMT_DOUBLE,&ctrType,&fmtValue);
		}
		if (pdhStatus == ERROR_SUCCESS && pCounterHandle != NULL) {
			if(wconfig.pm.enable_over)
				p_pms->over = wconfig.pm.over <= fmtValue.doubleValue ? true : false;
			if(wconfig.pm.enable_under)
				p_pms->under = wconfig.pm.under >= fmtValue.doubleValue ? true : false;
		} else { //G[͏𖞂ƂɂďI点
			p_pms->over = p_pms->under = true;
		}
		//print_log("timer");
		break;
	case PM_INIT:
		p_pms = (PM_STATE *)dwTime;
		if(wconfig.pm.enable_over) p_pms->over = false;
		if(wconfig.pm.enable_under) p_pms->under = false;
		//pX̃`FbN
		if(wconfig.pm.path_selected){
			pdhStatus = PdhValidatePath(wconfig.pm.PathBuffer);
		}
		if(!wconfig.pm.path_selected || pdhStatus != ERROR_SUCCESS){
			errormsg_pmpath();
			p_pms->over = p_pms->under = true;
			return;
		}
		// Open the query object.
		pdhStatus = PdhOpenQuery(0, 0, &hQuery);
		if (pdhStatus == ERROR_SUCCESS){
			pCounterHandle = (HCOUNTER *)GlobalAlloc(GPTR, sizeof(HCOUNTER));
		}
		if(pCounterHandle != NULL){
			pdhStatus = PdhAddCounter(hQuery, wconfig.pm.PathBuffer, 0, pCounterHandle);
		}
		// "Prime" counters that need two values to display a 
		//   formatted value.
		if (pdhStatus == ERROR_SUCCESS){
            pdhStatus = PdhCollectQueryData(hQuery);
		}
		p_pms->timerid = SetTimer(NULL, NULL, wconfig.pm.interval*1000, pm_timer_proc);
		break;
	case PM_EXIT:
		if(pCounterHandle != NULL){
			pdhStatus = PdhRemoveCounter(*pCounterHandle);
			pdhStatus = PdhCloseQuery(hQuery);
			GlobalFree(pCounterHandle);
			pCounterHandle = NULL;
		}
		break;
	}
}

//Oo
static void print_log(TCHAR *s)
{
	SYSTEMTIME st;

	GetLocalTime(&st);
	_ftprintf(g_fp,TEXT("wait.auo>"));
	_ftprintf(g_fp,TEXT(s));
	_ftprintf(g_fp,TEXT(" : %2.2d/%2.2d/%4.4d %2.2d:%2.2d:%2.2d\n"),
		st.wMonth, 
		st.wDay, 
		st.wYear,
		st.wHour, 
		st.wMinute, 
		st.wSecond);

}

//G[bZ[W
static void errormsg_wtimer(void)
{
	MessageBox(NULL, TEXT("WaitableTimerł܂ł"), NULL, MB_OK|MB_ICONERROR);
}

static void errormsg_nocond(void)
{
	MessageBox(NULL, TEXT("IЂƂw肳Ă܂"), NULL, MB_OK|MB_ICONERROR);
}

static void errormsg_timer(void)
{
	MessageBox(NULL, TEXT("IԂ̒lsł"), NULL, MB_OK|MB_ICONERROR);
}

static void errormsg_pmpath(void)
{
	MessageBox(NULL, TEXT("ptH[}XJE^̐ݒ肪sł"), NULL, MB_OK|MB_ICONERROR);
}

